#!/usr/bin/env python3
# Spočítá frekvence k-gramů v souboru soubor.txt
# (v každém řádku zvlášť).

from collections import defaultdict

k=3
kgramy=defaultdict(int)

for radek in open('soubor.txt'):
    # Rozdělíme na k-gramy
    # (ignorujeme znak konce řádku na poslední pozici)
    for i in range(len(radek)-k):
        kgramy[radek[i:i+k]] += 1

# Vytvoříme seznam dvojic (frekvence, k-gram), vypíšeme seřazeně
vystup = [ (f, g) for g, f in kgramy.items() ]
for f, g in reversed(sorted(vystup)):
    print(f, g)
